// File generated by CPPExt (Enum)
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _CSLib_NormalStatus_HeaderFile
#define _CSLib_NormalStatus_HeaderFile


//! <br>
//!  D1uIsNull : ||D1U|| <= Resolution <br>
//! <br>
//!  D1vIsNull : ||D1V|| <= Resolution <br>
//! <br>
//!  D1IsNull  : the first derivatives in the U and V parametric <br>
//!              directions have null length  : <br>
//!              ||D1U|| <= Resolution and ||D1V|| <= Resolution <br>
//! <br>
//!  D1uD1vRatioIsNull : the first derivative in the U direction has <br>
//!                      null length by comparison with the derivative <br>
//!                      in the V direction <br>
//!                      ||D1U|| / ||D1V|| <= RealEpsilon <br>
//! <br>
//!  D1vD1uRatioIsNull : the first derivative in the V direction has <br>
//!                      null length by comparison with the derivative <br>
//!                      in the U direction <br>
//!                      ||D1V|| / ||D1U|| <= RealEpsilon <br>
//! <br>
//!  D1uIsParallelD1v : the angle between the derivatives in the U and <br>
//!                     V direction is null (tolerance criterion given <br>
//!                     as input data) <br>
enum CSLib_NormalStatus { 
 CSLib_Singular,
CSLib_Defined,
CSLib_InfinityOfSolutions,
CSLib_D1NuIsNull,
CSLib_D1NvIsNull,
CSLib_D1NIsNull,
CSLib_D1NuNvRatioIsNull,
CSLib_D1NvNuRatioIsNull,
CSLib_D1NuIsParallelD1Nv
};


#ifndef _Standard_PrimitiveTypes_HeaderFile
#include <Standard_PrimitiveTypes.hxx>
#endif

#endif
