// File generated by CPPExt (Value)
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _GraphTools_SCList_HeaderFile
#define _GraphTools_SCList_HeaderFile

#ifndef _Standard_Address_HeaderFile
#include <Standard_Address.hxx>
#endif
#ifndef _Handle_GraphTools_SC_HeaderFile
#include <Handle_GraphTools_SC.hxx>
#endif
#ifndef _Handle_GraphTools_ListNodeOfSCList_HeaderFile
#include <Handle_GraphTools_ListNodeOfSCList.hxx>
#endif
#ifndef _Standard_Integer_HeaderFile
#include <Standard_Integer.hxx>
#endif
#ifndef _Standard_Boolean_HeaderFile
#include <Standard_Boolean.hxx>
#endif
class Standard_NoSuchObject;
class GraphTools_ListIteratorOfSCList;
class GraphTools_SC;
class GraphTools_ListNodeOfSCList;


#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Standard_Macro_HeaderFile
#include <Standard_Macro.hxx>
#endif


class GraphTools_SCList  {

public:

    void* operator new(size_t,void* anAddress) 
      {
        return anAddress;
      }
    void* operator new(size_t size) 
      { 
        return Standard::Allocate(size); 
      }
    void  operator delete(void *anAddress) 
      { 
        if (anAddress) Standard::Free((Standard_Address&)anAddress); 
      }
 // Methods PUBLIC
 // 


Standard_EXPORT GraphTools_SCList();


Standard_EXPORT   void Assign(const GraphTools_SCList& Other) ;
  void operator=(const GraphTools_SCList& Other) 
{
  Assign(Other);
}



Standard_EXPORT   Standard_Integer Extent() const;


Standard_EXPORT   void Clear() ;
~GraphTools_SCList()
{
  Clear();
}


  Standard_Boolean IsEmpty() const;


Standard_EXPORT   void Prepend(const Handle(GraphTools_SC)& I) ;


Standard_EXPORT   void Prepend(const Handle(GraphTools_SC)& I,GraphTools_ListIteratorOfSCList& theIt) ;


Standard_EXPORT   void Prepend(GraphTools_SCList& Other) ;


Standard_EXPORT   void Append(const Handle(GraphTools_SC)& I) ;


Standard_EXPORT   void Append(const Handle(GraphTools_SC)& I,GraphTools_ListIteratorOfSCList& theIt) ;


Standard_EXPORT   void Append(GraphTools_SCList& Other) ;


Standard_EXPORT   Handle_GraphTools_SC& First() const;


Standard_EXPORT   Handle_GraphTools_SC& Last() const;


Standard_EXPORT   void RemoveFirst() ;


Standard_EXPORT   void Remove(GraphTools_ListIteratorOfSCList& It) ;


Standard_EXPORT   void InsertBefore(const Handle(GraphTools_SC)& I,GraphTools_ListIteratorOfSCList& It) ;


Standard_EXPORT   void InsertBefore(GraphTools_SCList& Other,GraphTools_ListIteratorOfSCList& It) ;


Standard_EXPORT   void InsertAfter(const Handle(GraphTools_SC)& I,GraphTools_ListIteratorOfSCList& It) ;


Standard_EXPORT   void InsertAfter(GraphTools_SCList& Other,GraphTools_ListIteratorOfSCList& It) ;


friend class GraphTools_ListIteratorOfSCList;



protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


Standard_EXPORT GraphTools_SCList(const GraphTools_SCList& Other);


 // Fields PRIVATE
 //
Standard_Address myFirst;
Standard_Address myLast;


};

#define Item Handle_GraphTools_SC
#define Item_hxx <GraphTools_SC.hxx>
#define TCollection_ListNode GraphTools_ListNodeOfSCList
#define TCollection_ListNode_hxx <GraphTools_ListNodeOfSCList.hxx>
#define TCollection_ListIterator GraphTools_ListIteratorOfSCList
#define TCollection_ListIterator_hxx <GraphTools_ListIteratorOfSCList.hxx>
#define Handle_TCollection_ListNode Handle_GraphTools_ListNodeOfSCList
#define TCollection_ListNode_Type_() GraphTools_ListNodeOfSCList_Type_()
#define TCollection_List GraphTools_SCList
#define TCollection_List_hxx <GraphTools_SCList.hxx>

#include <TCollection_List.lxx>

#undef Item
#undef Item_hxx
#undef TCollection_ListNode
#undef TCollection_ListNode_hxx
#undef TCollection_ListIterator
#undef TCollection_ListIterator_hxx
#undef Handle_TCollection_ListNode
#undef TCollection_ListNode_Type_
#undef TCollection_List
#undef TCollection_List_hxx


// other Inline functions and methods (like "C++: function call" methods)
//


#endif
