// File generated by CPPExt (Value)
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _TColStd_StackOfInteger_HeaderFile
#define _TColStd_StackOfInteger_HeaderFile

#ifndef _Standard_Address_HeaderFile
#include <Standard_Address.hxx>
#endif
#ifndef _Standard_Integer_HeaderFile
#include <Standard_Integer.hxx>
#endif
#ifndef _Handle_TColStd_StackNodeOfStackOfInteger_HeaderFile
#include <Handle_TColStd_StackNodeOfStackOfInteger.hxx>
#endif
#ifndef _Standard_Boolean_HeaderFile
#include <Standard_Boolean.hxx>
#endif
class Standard_NoSuchObject;
class TColStd_StackIteratorOfStackOfInteger;
class TColStd_StackNodeOfStackOfInteger;


#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Standard_Macro_HeaderFile
#include <Standard_Macro.hxx>
#endif


class TColStd_StackOfInteger  {

public:

    void* operator new(size_t,void* anAddress) 
      {
        return anAddress;
      }
    void* operator new(size_t size) 
      { 
        return Standard::Allocate(size); 
      }
    void  operator delete(void *anAddress) 
      { 
        if (anAddress) Standard::Free((Standard_Address&)anAddress); 
      }
 // Methods PUBLIC
 // 


Standard_EXPORT TColStd_StackOfInteger();


Standard_EXPORT  const TColStd_StackOfInteger& Assign(const TColStd_StackOfInteger& Other) ;
 const TColStd_StackOfInteger& operator =(const TColStd_StackOfInteger& Other) 
{
  return Assign(Other);
}


  Standard_Boolean IsEmpty() const;

  Standard_Integer Depth() const;


Standard_EXPORT  const Standard_Integer& Top() const;


Standard_EXPORT   void Push(const Standard_Integer& I) ;


Standard_EXPORT   void Pop() ;


Standard_EXPORT   void Clear() ;
~TColStd_StackOfInteger()
{
  Clear();
}



Standard_EXPORT   Standard_Integer& ChangeTop() ;


friend class TColStd_StackIteratorOfStackOfInteger;



protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


Standard_EXPORT TColStd_StackOfInteger(const TColStd_StackOfInteger& Other);


 // Fields PRIVATE
 //
Standard_Address myTop;
Standard_Integer myDepth;


};

#define Item Standard_Integer
#define Item_hxx <Standard_Integer.hxx>
#define TCollection_StackNode TColStd_StackNodeOfStackOfInteger
#define TCollection_StackNode_hxx <TColStd_StackNodeOfStackOfInteger.hxx>
#define TCollection_StackIterator TColStd_StackIteratorOfStackOfInteger
#define TCollection_StackIterator_hxx <TColStd_StackIteratorOfStackOfInteger.hxx>
#define Handle_TCollection_StackNode Handle_TColStd_StackNodeOfStackOfInteger
#define TCollection_StackNode_Type_() TColStd_StackNodeOfStackOfInteger_Type_()
#define TCollection_Stack TColStd_StackOfInteger
#define TCollection_Stack_hxx <TColStd_StackOfInteger.hxx>

#include <TCollection_Stack.lxx>

#undef Item
#undef Item_hxx
#undef TCollection_StackNode
#undef TCollection_StackNode_hxx
#undef TCollection_StackIterator
#undef TCollection_StackIterator_hxx
#undef Handle_TCollection_StackNode
#undef TCollection_StackNode_Type_
#undef TCollection_Stack
#undef TCollection_Stack_hxx


// other Inline functions and methods (like "C++: function call" methods)
//


#endif
