// File generated by CPPExt (Transient)
//
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _TopLoc_Datum3D_HeaderFile
#define _TopLoc_Datum3D_HeaderFile

#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Handle_TopLoc_Datum3D_HeaderFile
#include <Handle_TopLoc_Datum3D.hxx>
#endif

#ifndef _gp_Trsf_HeaderFile
#include <gp_Trsf.hxx>
#endif
#ifndef _MMgt_TShared_HeaderFile
#include <MMgt_TShared.hxx>
#endif
#ifndef _Standard_OStream_HeaderFile
#include <Standard_OStream.hxx>
#endif
class Standard_ConstructionError;
class gp_Trsf;


//! Describes a coordinate transformation, i.e. a change <br>
//! to an elementary 3D coordinate system, or position in 3D space. <br>
//! A Datum3D is always described relative to the default datum. <br>
//! The default datum is described relative to itself: its <br>
//! origin is (0,0,0), and its axes are (1,0,0) (0,1,0) (0,0,1). <br>
class TopLoc_Datum3D : public MMgt_TShared {

public:
 // Methods PUBLIC
 // 

//! Constructs a default Datum3D. <br>
Standard_EXPORT TopLoc_Datum3D();

//! Constructs a Datum3D form a Trsf from gp. An error is <br>
//!          raised if the Trsf is not a rigid transformation. <br>
Standard_EXPORT TopLoc_Datum3D(const gp_Trsf& T);
//! Returns a gp_Trsf which, when applied to this datum, <br>
//! produces the default datum. <br>
 const gp_Trsf& Transformation() const;


//! Writes the contents of this Datum3D to the stream S. <br>
Standard_EXPORT   void ShallowDump(Standard_OStream& S) const;
//Standard_EXPORT ~TopLoc_Datum3D();




 // Type management
 //
 Standard_EXPORT const Handle(Standard_Type)& DynamicType() const;
 //Standard_EXPORT Standard_Boolean	       IsKind(const Handle(Standard_Type)&) const;

protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //
gp_Trsf myTrsf;


};


#include <TopLoc_Datum3D.lxx>



// other Inline functions and methods (like "C++: function call" methods)
//
inline void ShallowDump(const Handle_TopLoc_Datum3D& me,Standard_OStream& S) {
 me->ShallowDump(S);
}



#endif
